/*
 * Routines for basic PI access
 */

#include "PI.h"

volatile struct PI_regs_s * const PI_regs = (struct PI_regs_s *)0xa4600000;

int PI_busy() {
    return PI_regs->status & (PI_status_DMA_busy | PI_status_IO_busy);
}
/* read from PI */
void PI_read(void * ram_address, unsigned long pi_address, unsigned long len) {
    while (PI_busy()) ;
    PI_regs->ram_address = ram_address;
    PI_regs->pi_address = pi_address;
    PI_regs->write_length = len-1;
    while (PI_busy()) ;
}
/* write to PI */
void PI_write(void * ram_address, unsigned long pi_address, unsigned long len) {
    while (PI_busy()) ;
    PI_regs->ram_address = ram_address;
    PI_regs->pi_address = pi_address;
    PI_regs->read_length = len-1;
    while (PI_busy()) ;
}
