#ifndef _AUDIO_H
#define _AUDIO_H

#include <libn64.h>

#define AUDIO_INTERRUPT_DRIVEN
#define AUDIO_DEBUG

// specs
enum {AUDIO_FREQUENCY=32000};

#define AUDIO_BUFFER_SAMPLES 0x100
#define AUDIO_BUFFER_COUNT 7

// user functions

// setup
void audio_init(void);

// request a buffer to write in
short * audio_getbuf(void);

// how many samples in this buffer?
int audio_getbufsamplecount(void);

// announce that I'm done with the buffer
void audio_done(void);

// debug

#ifdef AUDIO_DEBUG
extern unsigned int audio_buffers_deferred;
extern int audio_readbuf;
extern int audio_writebuf;
extern int audio_restarts;
#endif

#endif
